﻿using Syncfusion.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace DataGrid3_1
{


    public partial class MainPage : ContentPage
    {
        public static bool sortBullCode = false;

        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            dataGrid.SortComparers.Clear();
            if (changebtn.Text == "OrderID")
            {
                dataGrid.SortComparers.Add(new SortComparer()
                {
                    PropertyName = "ShipCountry",
                    Comparer = new CustomComparer("ShortName")
                });
                changebtn.Text = "ShortName";
            }
            else
            {
                dataGrid.SortComparers.Add(new SortComparer()
                {
                    PropertyName = "ShipCountry",
                    Comparer = new CustomComparer("OrderID")
                });
                changebtn.Text = "OrderID";
            }
        }

        public class CustomComparer : IComparer<Object>, ISortDirection
        {

            public string MappingName;

            public CustomComparer(string mappingName)
            {
                MappingName = mappingName;
            }

            public int Compare(object x, object y)
            {
                //For OrderInfo type data
                //if (x.GetType() == typeof(OrderInfo))
                if (MappingName == "OrderID")
                {
                    int nameX;
                    int nameY;

                    //Calculating the length of FirstName in OrderInfo objects
                    nameX = ((OrderInfo)x).OrderID;
                    nameY = ((OrderInfo)y).OrderID;

                    // Objects are compared and return the SortDirection
                    if ((int)nameX.CompareTo((int)nameY) > 0)
                        return SortDirection == ListSortDirection.Descending ? 1 : -1;
                    else if (nameX.CompareTo(nameY) == -1)
                        return SortDirection == ListSortDirection.Descending ? -1 : 1;
                    else
                        return 0;

                }
                else if (MappingName == "ShortName")
                {
                    string nameX;
                    string nameY;

                    //Calculating the length of FirstName in OrderInfo objects
                    nameX = ((OrderInfo)x).ShortName;
                    nameY = ((OrderInfo)y).ShortName;

                    // Objects are compared and return the SortDirection
                    if (nameX.CompareTo(nameY) > 0)
                        return SortDirection == ListSortDirection.Descending ? 1 : -1;
                    else if (nameX.CompareTo(nameY) == -1)
                        return SortDirection == ListSortDirection.Descending ? -1 : 1;
                    else
                        return 0;

                }
                else
                {
                    return 0;
                }
            }

            //Gets or sets the SortDirection value
            public ListSortDirection SortDirection { get; set; }
        }
    }
}

